#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int GetCurrentVersion(void)
{
	FILE *ifp=fopen("yssvnrevision.h","r");
	if(NULL!=ifp)
	{
		char hdrStr[256];
		while(NULL!=fgets(hdrStr,255,ifp))
		{
			hdrStr[255]=0;  // To be absolutely safe.

			for(int i=0; hdrStr[i]!=0; ++i)
			{
				if(0==strncmp("YsSvnRevisionString",hdrStr+i,19))
				{
					for(int j=i+19; hdrStr[j]!=0; ++j)
					{
						if('\"'==hdrStr[j])
						{
							fclose(ifp);
							return atoi(hdrStr+j+1);
						}
					}
				}
			}
		}
		fclose(ifp);
	}
	return -1;
}

int main(void)
{
	int curVer=GetCurrentVersion();
	printf("Current version in the header=%d\n",curVer);

	FILE *fp=fopen("revision.txt","r");
	if(NULL!=fp)
	{
		char revStr[256];
		if(NULL!=fgets(revStr,255,fp))
		{
			int err=0;

			for(int i=0; 0!=revStr[i]; i++)
			{
				if((revStr[i]<'0' || '9'<revStr[i]) &&
				   (revStr[i]<'a' || 'z'<revStr[i]) &&
				   (revStr[i]<'A' || 'Z'<revStr[i]))
				{
					revStr[i]=0;
					break;
				}
			}
			fclose(fp);

			printf("Revision String=[%s]\n",revStr);
			if(curVer!=atoi(revStr))
			{
				FILE *ofp=fopen("yssvnrevision.h","w");
				if(NULL!=ofp)
				{
					fprintf(ofp,"#ifndef YSSVNREVISION_H_IS_INCLUDED\n");
					fprintf(ofp,"#define YSSVNREVISION_H_IS_INCLUDED\n");
					fprintf(ofp,"const char *YsSvnRevisionString=\"%s\";\n",revStr);
					fprintf(ofp,"#endif\n");

					fclose(ofp);
				}
				else
				{
					err=-1;
				}

				return err;
			}
			else
			{
				printf("Doesn't have to update.\n");
				return 0;
			}
		}
	}

	if(NULL!=fp)
	{
		fclose(fp);
	}

	return -1;
}

