/* ////////////////////////////////////////////////////////////

Polygon Crest
Copyright (c) 2015 Soji Yamakawa.  All rights reserved.
http://www.ysflight.com

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

File Name: ysshellext_facegrouputil.cpp
//////////////////////////////////////////////////////////// */

#include "ysshellext_facegrouputil.h"

void YsShellExt_FaceGroupCandidate::CleanUp(void)
{
	grpArray.CleanUp();
}
const YsArray <YsShellExt_FaceGroupCandidate::GroupCandidate> &YsShellExt_FaceGroupCandidate::FaceGroupCandidate(void) const
{
	return grpArray;
}


class YsShellExt_FaceGroupCandidate::ForcePolygonToBeInFaceGroupTrackingCondition : public YsShellExt_TrackingUtil::SearchCondition
{
public:
	virtual YSRESULT TestPolygon(const YsShellExt &shl,YsShellPolygonHandle plHd) const;
	virtual YSRESULT TestEdge(const YsShellExt &shl,YsShellVertexHandle edVtHd0,YsShellVertexHandle edVtHd1) const;
};

/* virtual */ YSRESULT YsShellExt_FaceGroupCandidate::ForcePolygonToBeInFaceGroupTrackingCondition::TestPolygon(const YsShellExt &shl,YsShellPolygonHandle plHd) const
{
	if(NULL==shl.FindFaceGroupFromPolygon(plHd))
	{
		return YSOK;
	}
	return YSERR;
}

/* virtual */ YSRESULT YsShellExt_FaceGroupCandidate::ForcePolygonToBeInFaceGroupTrackingCondition::TestEdge(const YsShellExt &shl,YsShellVertexHandle edVtHd0,YsShellVertexHandle edVtHd1) const
{
	if(0==shl.GetNumConstEdgeUsingEdgePiece(edVtHd0,edVtHd1))
	{
		return YSOK;
	}
	return YSERR;

}

void YsShellExt_FaceGroupCandidate::ForcePolygonToBeInFaceGroup(const YsShellExt &shl)
{
	CleanUp();

	ForcePolygonToBeInFaceGroupTrackingCondition cond;

	for(auto plHd : shl.AllPolygon())
	{
		if(YSOK==cond.TestPolygon(shl,plHd))
		{
			grpArray.Increment();
			grpArray.Last().plHdArray=YsShellExt_TrackingUtil::MakeEdgeConnectedPolygonGroup(shl,plHd,&cond);
		}
	}
}
