/* ////////////////////////////////////////////////////////////

Polygon Crest
Copyright (c) 2015 Soji Yamakawa.  All rights reserved.
http://www.ysflight.com

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

File Name: ysshellextedit_duplicateutil.h
//////////////////////////////////////////////////////////// */

#ifndef YSSHELLEXTEDIT_DUPLICATEUTIL_IS_INCLUDED
#define YSSHELLEXTEDIT_DUPLICATEUTIL_IS_INCLUDED
/* { */

#include "ysshellext_duplicateutil.h"

class YsShellExtEdit_DuplicateUtil : public YsShellExt_DuplicateUtil
{
public:
	/*! Make a copy of entities stored in this class. */
	YSRESULT Paste(class YsShellExtEdit &dstShl);

	/*! Make a copy of entities stored in this class after transforming by the matrix. */
	YSRESULT PasteWithTransformation(class YsShellExtEdit &dstShl,const YsMatrix4x4 &tfm);

	/*! Make a copy of a mirror-image of the entities stored in dupUtil.
	    The flag dontMakeCopyOnSymmPlane can be YSTRUE only when a copy is made within the same shell. */
	YSRESULT MakeAxisymmetric(class YsShellExtEdit &shl,const int component,YSBOOL dontMakeCopyOnSymmPlane,YSBOOL deletePolygonOnSymmPlane);

	/*! Make a copy of a mirror-image of the entities stored in dupUtil.
	    The flag dontMakeCopyOnSymmPlane can be YSTRUE only when a copy is made within the same shell. */
	YSRESULT MakeBySymmetryPlane(class YsShellExtEdit &shl,const YsPlane &pln,YSBOOL dontMakeCopyOnSymmPlane,YSBOOL deletePolygonOnSymmPlane);

private:
	void PasteConstEdge(class YsShellExtEdit &dstShl);
	void PasteConstEdgeForMirrorImage(class YsShellExtEdit &shl);
	void PasteFaceGroup(class YsShellExtEdit &dstShl);
};



/* } */
#endif
