#version "YS_GLSL_VERSION"

uniform sampler2D textureIdent;

varying "YS_GLSL_MIDP" vec2 texCoordOut;
varying "YS_GLSL_LOWP" vec4 color;

#include "YS_GLSL_FOG_VARIABLES.glsl"
#include "YS_GLSL_ALPHA_CUTOFF_PARAMETER.glsl"
#include "YS_GLSL_POINT_SPRITE_VARIABLE.glsl"

void main()
{
	if(YSGLSL_POINTSPRITE_CLIPPING_CIRCLE==pointClippingType)
	{
		"YS_GLSL_MIDP" vec2 t=(gl_PointCoord.xy*2.0)-vec2(1.0,1.0);
		if(1.0<=dot(t,t))
		{
			discard;
		}
	}

	if(true==textureEnabled)
	{
		"YS_GLSL_MIDP" vec2 texCoord=texCoordOut+gl_PointCoord*texCoordRange;
		"YS_GLSL_LOWP" vec4 texcell=texture2D(textureIdent,texCoord);
		gl_FragColor=color*texcell;
	}
	else
	{
		gl_FragColor=color;
	}

	// gl_FragColor.rg=gl_PointCoord;  For debugging.

	#include "YS_GLSL_ALPHA_CUTOFF_IN_FRAGMENT_SHADER.glsl"
	#include "YS_GLSL_FOGCALCULATION_IN_FRAGMENTSHADER.glsl"
}
