uniform mat4 projection;
uniform mat4 modelView;
uniform sampler2D textureIdent;

attribute "YS_GLSL_HIGHP" vec3 vertex;
attribute "YS_GLSL_LOWP" vec4 colorIn;
attribute "YS_GLSL_LOWP" vec2 texCoordIn;
attribute "YS_GLSL_MIDP" float pointSizeIn;

varying "YS_GLSL_LOWP" vec4 color;
varying "YS_GLSL_MIDP" vec2 texCoordOut;

#include "YS_GLSL_FOG_VARIABLES.glsl"
#include "YS_GLSL_ZOFFSET_VARIABLE.glsl"
#include "YS_GLSL_POINT_SPRITE_VARIABLE.glsl"

void main()
{
	#include "YS_GLSL_VIEW_TRANSFORM_IN_VERTEX_SHADER.glsl"
	texCoordOut=texCoordIn;
	color=colorIn;
	// if(pointSizeMode==YS_GLSL_POINTSPRITE_SIZE_IN_PIXEL)
	{
		gl_PointSize=pointSizeIn;
	}
	// else if(pointSizeMode==YS_GLSL_POINTSPRITE_SIZE_IN_3DSPACE)
	// {
	// }

	#include "YS_GLSL_FOG_CALCULATION_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_PROJECTION_TRANSFORM_IN_VERTEX_SHADER.glsl"
	#include "YS_GLSL_ZOFFSET_IN_VERTEXSHADER.glsl"
}
