#include "ysglbuffer_sphereutil.h"



YSRESULT YsGLCreateSphereOutlineVertexBufferForGL_LINES(YsGLVertexBuffer &vtxBuf,const double radius,int nDiv)
{
	vtxBuf.CleanUp();

	for(int i=0; i<nDiv; ++i)
	{
		const double a0=YsPi*2.0*(double)i/(double)nDiv;
		const double a1=YsPi*2.0*(double)(i+1)/(double)nDiv;

		const double x0=radius*cos(a0);
		const double y0=radius*sin(a0);
		const double x1=radius*cos(a1);
		const double y1=radius*sin(a1);

		vtxBuf.AddVertex(x0,y0,0.0);
		vtxBuf.AddVertex(x1,y1,0.0);

		vtxBuf.AddVertex(x0,0.0,y0);
		vtxBuf.AddVertex(x1,0.0,y1);

		vtxBuf.AddVertex(0.0,x0,y0);
		vtxBuf.AddVertex(0.0,x1,y1);
	}

	return YSOK;
}

